var initKeyPrefix = "apple-init-";

/*RSS vars*/
var htmlFeedURL = null;
var feedURLKey = "feedURL";
var numItemsToShow = 1;
var numItemsToShowKey = "numItemsToShow";
var maxAgeToShowKey = "maxAgeToShow";
var maxAgeToShow = 0;
var showDateKey = "showDate";
var showDate = 1;
var feed = { url: null, title: "" };
var newFeedURL = null;
var feedAdded = false;
var last_updated = 0;
var xml_request = null;
var slider;

/*resizing vars*/
var gInfoButton, gDoneButton;
var gFrontHeight, gFrontWidth;

var scrollArea;


function setup()
{
	/*RSS setup code*/
	numItemsToShow = getPropertyFromHTML(numItemsToShowKey, numItemsToShow);
	maxAgeToShow   = getPropertyFromHTML(maxAgeToShowKey, maxAgeToShow);
	showDate	   = getPropertyFromHTML(showDateKey, showDate);

	//slider = document.getElementById("slider");

	/*resizing init code*/
gInfoButton = new AppleInfoButton(document.getElementById("info"), document.getElementById("front"), "black", "black", showPrefs);
gDoneButton = new AppleGlassButton(document.getElementById("done"), "OK", hidePrefs);

/*init scrollbar*/
scrollArea = AppleCreateScrollArea('contentarea', 'scrollbar');

	if (window.widget) {
		htmlFeedURL = getFeedSource();
		feed.url = htmlFeedURL;
		setFeedURL(feed.url);
	}
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
/*	if (timer != null){
		clearInterval(timer);
		timer = null;
}*/


}

function show()
{
	// your widget has just been shown.	 restart any timers
	// and adjust your interface as needed
	var now = (new Date).getTime();

	// only check if 3 minutes have passed
	if ((now - last_updated) > 180000) {
		if (xml_request != null) {
			xml_request.abort();
			xml_request = null;
		}
		xml_request = new XMLHttpRequest();

		xml_request.onload = function(e) {xml_loaded(e, xml_request);}
		xml_request.overrideMimeType("text/xml");
		xml_request.open("GET", feed.url);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
	}


}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";

	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";

	if (window.widget)
		setTimeout('widget.performTransition();', 0);

	scrollArea.refresh();
}

if (window.widget) {
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

// Retrieve the contents of an HTML div
function getPropertyFromHTML(propertyKey, defaultValue)
{
	var element = document.getElementById(initKeyPrefix + propertyKey);
	if (element) {
		return trim(element.innerHTML);
	}
	else {
		return defaultValue;
	}
}

function getFeedSource()
{
	var url = getPropertyFromHTML(feedURLKey);

	if (url) {
		if (url.substring(0,7).toLowerCase() != "http://") {
			url = "http://" + url;
		}
	}
	return url;
}

function findChild(element, nodeName)
{
	var child;

	for (child = element.firstChild; child != null; child = child.nextSibling) {
		if (child.nodeName == nodeName)
			return child;
	}

	return null;
}

function xml_loaded (e, request)
{
	xml_request = null;
	if (request.responseXML) {
		var contents = document.getElementById('content');

		// Remove the old entries
		removeEntriesFromContents(contents);

		// Get the top level element
		var feedRootElement = request.responseXML.documentElement;
		if (!feedRootElement) { alert("no root element"); return; }

		// call the RSS feed function and get the drivel
		var results;
		results = getRSSFeed(feedRootElement);

		var onlineuserslist;
		onlineuserslists = getonlineuserslist(feedRootElement);


		// Got no results?
		if (results == null || results.length < 1)
		return;

		if (feed.url.indexOf("phobos.apple.com") != -1) {
			// iTunes demo, sort by Title
			results.sort(compTop10Func);
		} else {
			// sort by date
			results.sort (compFunc);
		}

		// Limit entries to top N, etc.
		results = filterEntries(results);


		// Generate the display
		addEntriesToContents(contents, results);

		// update the scrollbar so scrollbar matches new data
		scrollArea.refresh();

		// set last_updated to the current time to keep track of the last time a request was posted
		last_updated = (new Date).getTime();
	}
}

function removeEntriesFromContents(contents)
{
	while (contents.hasChildNodes()) {
		contents.removeChild(contents.firstChild);
	}
}




function addEntriesToContents(contents, entries)
{
	/// sto hacks
	/// call the new creatuserlist function instead of createrow for this wan!
	var row = createuserlist (onlineusersblurb);
	//alert(row);
	contents.appendChild(row);
	//alert(contents);
	/// sto hacks

	// copy title and date into rows for display. Store link so it can be used when user
	// clicks on title
	nItems = entries.length;
	var even = true;


	for (var i = 0; i < nItems; ++i) {
		var item = entries[i];
		var row = createRow (item.title, item.link, item.date, item.description, even, item.author);
		even = !even;

		contents.appendChild (row);
	}
}

function filterEntries(entries)
{
	var result = new Array();

	var cutoffDate = null;
	if (maxAgeToShow) {
		cutoffDate = new Date((new Date()).getTime() - maxAgeToShow);
	}

	for (var i = 0; i < numItemsToShow; i++) {
		var entry = entries[i];
		var entryDate = entry.date;
		if (entryDate == null) {
			// No date, pretend it's today
			entryDate = new Date();
		}
		if (cutoffDate == null || entryDate >= cutoffDate) {
			result.push(entry);
		}
	}

	return result;
}

// Correct hyperlinks in a document fragment to use the openURL function
function fixLinks(htmlFragment)
{
	// Collect all the links
	var links = htmlFragment.getElementsByTagName("a");
	for (var i = 0; i < links.length; i++) {
		var aNode = links[i];
		// Send them to our clickOnLink function
		aNode.onclick = clickOnLink;
	}
}


Date.prototype.setISO8601 = function (string) {
	var regexp = "([0-9]{4})(-([0-9]{2})(-([0-9]{2})" +
		"(T([0-9]{2}):([0-9]{2})(:([0-9]{2})(\.([0-9]+))?)?" +
		"(Z|(([-+])([0-9]{2}):([0-9]{2})))?)?)?)?";
	var d = string.match(new RegExp(regexp));

	var offset = 0;
	var date = new Date(d[1], 0, 1);

	if (d[3]) { date.setMonth(d[3] - 1); }
	if (d[5]) { date.setDate(d[5]); }
	if (d[7]) { date.setHours(d[7]); }
	if (d[8]) { date.setMinutes(d[8]); }
	if (d[10]) { date.setSeconds(d[10]); }
	if (d[12]) { date.setMilliseconds(Number("0." + d[12]) * 1000); }
	if (d[14]) {
		offset = (Number(d[16]) * 60) + Number(d[17]);
		offset *= ((d[15] == '-') ? 1 : -1);
	}

	offset -= date.getTimezoneOffset();
	time = (Number(date) + (offset * 60 * 1000));
	this.setTime(Number(time));
}

////// get the RSS feed
function getRSSFeed(rss)
{
	// Get single subordinate channel element
	var channel = findChild( rss, 'channel');
	if (!channel) {alert("no <channel> element"); return;}

	// get the online users string, which lives in the "description" tags
	onlineusersblurb = findChild(channel, "description");
	onlineusersblurb = onlineusersblurb.childNodes[0].nodeValue;
	//alert("online users	 ====> "+onlineusersblurb);


	var results = new Array;

	results[0] = onlineusersblurb;


	for(var item = channel.firstChild; item != null; item = item.nextSibling) {

				if( item.nodeName == 'item' ) {
			var title = findChild(item, 'title');

			// we have to have the title to include the item in the list
			if( title != null ) {
				var link = findChild(item, 'link');

				/////////////// stuzzbot wans ///////////////////
				var author = findChild(item, 'author');

			//if (!author) {alert("no <author> element"); return;}

				var pubDate = findChild(item, 'pubDate');
				if (pubDate) {
					pubDate = pubDate.firstChild.data;
				}
				if (pubDate && feed.url.indexOf("http://www.washingtonpost.com") == 0) {
					var dArray = pubDate.split(/\s/);
					pubDate = dArray[0] + " " + dArray[1] + " " + dArray[2] + " " + dArray[5] + " " + dArray[3] + " " + dArray[4];
				}
				var description = findChild(item, 'description');


				results[results.length] = {title:title.firstChild.data,
					link:(link != null ? link.firstChild.data : null),
					author:(author != null ? author.firstChild.data : null),
					date:(pubDate != null ? new Date(Date.parse(pubDate)) : null),
					description:(description != null ? description.firstChild.data : null)
				}
			}
		}
	}


	return results;

}




////// get the online users list from the RSS feed
function getonlineuserslist(rss)
{
// Get single subordinate channel element
var channel = findChild( rss, 'channel');
	if (!channel) {alert("no <channel> element"); return;}

	// get the online users string, which lives in the "description" tags
	onlineusersblurb = findChild(channel, "description");
	onlineusersblurb = onlineusersblurb.childNodes[0].nodeValue;
	//alert("online users	 ====> "+onlineusersblurb);

	return onlineusersblurb;

}





function compTop10Func(a, b)
{
	var aInt = parseInt(a.title);
	var bInt = parseInt(b.title);
	if (aInt < bInt)
		return -1;
	else if (aInt > bInt)
		return 1;
	else
		return 0;
}

function compTitleFunc(a, b)
{
	if (a.title < b.title)
		return -1;
	else if (a.title > b.title)
		return 1;
	else
		return 0;
}

function compFunc(a, b)
{
	if (a.date < b.date)
		return 1;
	else if (a.date > b.date)
		return -1;
	else
		return 0;
}



//////// createuserlist function //////////////////

/// takes the onlineuserblurb string and formats it up as the title attribute of a <dfn> tag, attached to the "who's online" icon

function createuserlist (onlineuserblurb)
{
	var userlist = document.createElement('div');
	userlist.setAttribute('class', 'userlist ');

	var dfntag = document.createElement('dfn');
	dfntag.setAttribute('title', onlineusersblurb);
	userlist.appendChild(dfntag);

	var img = document.createElement('img');
	img.setAttribute('src', 'grafix/personicon.png');
	dfntag.appendChild(img);

	//alert("userlist ==>"+userlist);
	return userlist;
}







//////// stuzzbot added author here //////////////////
function createRow (title, link, date, description, even, author)
{
	var article = document.createElement('div');
	article.setAttribute('class', 'article ' + (even ? "even" : "odd"));

	var articlefooter = document.createElement('div');
	articlefooter.setAttribute('class', 'articlefooter');
	article.appendChild(articlefooter);

	var articlehead = document.createElement('a');
	articlehead.setAttribute('class', 'articlehead');

	if (link != null) {
		articlehead.setAttribute('the_link', link);
		articlehead.setAttribute('onclick', 'clickOnTitle(event, this);');
		articlehead.setAttribute('href', '#');
	}

	var subject_div = document.createElement('div');
	subject_div.setAttribute('class', 'subject');
	subject_div.innerText = title;
	articlehead.appendChild(subject_div);

	if (date != null) {
		var date_div = document.createElement('div');
		date_div.setAttribute ('class', 'date');
		if (showDate == 1) {
			date_div.innerText = createDateStr(date);
		}

		articlehead.appendChild(date_div);
	}

	article.appendChild(articlehead);

	/////////// stuzzbot added this quadrant /////////////
	if (author != null) {
		var author_div = document.createElement('div');
		author_div.setAttribute ('class', 'author');
		author_div.innerHTML = "by "+author+":";
		article.appendChild(author_div);
	}
	/////////////////////////////////////


	if (description != null) {
		var desc_div = document.createElement('div');
		desc_div.setAttribute('class', 'articlebody');
		desc_div.innerHTML = description;

		// Clean up hyperlinks
		fixLinks(desc_div);

		article.appendChild(desc_div);
	}


	return article;
}

function createDateStr (date)
{
	//alert("date ===>"+date);
	var month;
	switch (date.getMonth()) {
		case 0: month = 'jan'; break;
		case 1: month = 'feb'; break;
		case 2: month = 'mar'; break;
		case 3: month = 'apr'; break;
		case 4: month = 'may'; break;
		case 5: month = 'jun'; break;
		case 6: month = 'jul'; break;
		case 7: month = 'aug'; break;
		case 8: month = 'sep'; break;
		case 9: month = 'oct'; break;
		case 10: month = 'nov'; break;
		case 11: month = 'dec'; break;
	}
	/// add 1900 to year - otherwise it comes out as 106!
	var year = (date.getYear()+1900);
	//alert("year ===>"+year);
	return date.getDate() + ' ' + month + ' ' + year;
}

// Open in the browser instead of in the widget
function clickOnLink()
{
	if (window.widget) {
		widget.openURL(this.href);
		return false;
	}
}

function clickOnTitle(event, div)
{
	if (window.widget) {
		widget.openURL(div.the_link);
	}
}

function clickOnFeedTitle(event)
{
	if (window.widget) {
		widget.openURL(feed.url);
	}
}

function setFeedURL(newURL)
{
	newFeedURL = newURL;
}

function scaleArticles( value )
{
	var content = document.getElementById('content');
	content.style.appleLineClamp = value + "%";
}

function endScale()
{
	//scrollArea.refresh();
}

function scaleTo( value ) {
	slider.value = value;
	scaleArticles( value );
}

function scaleToMin() {
	scaleTo( slider.min);
}

function scaleToMax() {
	scaleTo( slider.max );
}




/*resizing code*/


function showPrefs()
{

	// store the front height and width values to restore on return to front
	gFrontHeight = window.innerHeight;

	gFrontWidth = window.innerWidth;



	// Two AppleRect objects store the starting and finshing rectangle sizes
	var startingRect = new AppleRect (0, 0, window.innerWidth, window.innerHeight);
	var finishingRect = new AppleRect (0, 0, 243, 150);

	// The RectAnimation specifies the range of values and the handler to call at the animator's interval
	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );

	// The Animator is the timer for the animation
	var currentAnimator = new AppleAnimator (500, 13);

	// Associate the animator and animation
	currentAnimator.addAnimation(currentRectAnimation);

	// Set a handler to be called when the animation is done (in this case, flip the widget to its back)
	currentAnimator.oncomplete = flipToBack;

	// Once everything is set up, start the animation
	currentAnimator.start();

}

function flipToBack()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}

	front.style.display="none";
	back.style.display="block";

	if (window.widget){
		setTimeout ('widget.performTransition();', 0);
		widget.setCloseBoxOffset(13,14);
	}
}

// The rectHandler is called each interval by the Animator.	 It passes in the animation values at
// this point in the animation.	 The values are used to resize parts of the interface and the
// widget as a whole

function rectHandler( rectAnimation, currentRect, startingRect, finishingRect )
{
	document.getElementById("midrow").style.height = (currentRect.bottom-14);
	document.getElementById("botrow").style.top = (currentRect.bottom-14);
	window.resizeTo(currentRect.right, currentRect.bottom);
}


function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}

	back.style.display="none";
	front.style.display="block";

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
		widget.setCloseBoxOffset(7,9);
	}

	// Once the flip to the front is complete, flipToFront resizes the widget back to its former size.
	setTimeout("flipToFront()", 750);

}


// flipToFront uses another AppleRectAnimation to resize the widget to its previous size

function flipToFront()
{
	var startingRect = new AppleRect (0, 0, 243, 150);
	var finishingRect = new AppleRect (0, 0, gFrontWidth, gFrontHeight);

	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );

	var currentAnimator = new AppleAnimator (500, 13);
	currentAnimator.addAnimation(currentRectAnimation);
	currentAnimator.start();
}



// Standard widget resize code follows...

var growboxInset;

function mouseDown(event)
{

	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);

	growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};

	event.stopPropagation();
	event.preventDefault();
}

function mouseMove(event)
{
	// checks if the reported event data is legit or not
	if((event.x == -1 ) ) { break; }

	var x = event.x + growboxInset.x;
	var y = event.y + growboxInset.y;

	if(x < 243)		// an arbitrary minimum width
		x = 243;

	if(y < 150)		// an arbitrary minimum height
		y = 150;

	document.getElementById("midrow").style.height = (y-14);
	document.getElementById("botrow").style.top = (y-14);
	window.resizeTo(x,y);

	event.stopPropagation();
	event.preventDefault();

	/*refresh the scrollbar after window size change*/
	scrollArea.refresh();
}

function mouseUp(event)
{
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);

	event.stopPropagation();
	event.preventDefault();
}

